<?php
/**
 *
 * Author: Steve Bourgeois <owl@bozzit.com>
 *
 * Owl Ultra Lite
 *
 * Copyright (c) 2005-2006 Bozz IT Consulting Inc
 * Licensed under the GNU GPL. For full terms see http://www.gnu.org/licenses/licenses.html#TOCGPL
 *
 */

require_once("config/owl.php");
require_once("lib/owlulite.lib.php");

import_request_variables('pgc');

global $owl_lang;

$iNumberOfOptionalColumns = $default->display_permissions + $default->display_size + $default->display_last_modified;


if (!isset($folder) || $folder == "")
{
   $default->root_folder = $default->root_folder . "/" . $sRootFolderName;
   $sRecyclePath = $sRootFolderName;
   $folder = $sRootFolderName;
}
else
{
   $folder = ereg_replace("\.\.","",$folder);
   $default->root_folder .= "/" . $folder;
   $sRecyclePath = $folder;
} 
if(isset($btn_add_file))
{
   $sMessage = "";
   if (isset($default->upload_permit_ext))
   {
      $file_extension = fFindFileExtension ( $_FILES['userfile']['name']);
      foreach ($default->upload_permit_ext as $permit)
      {
         if ($file_extension == $permit)
         {
            $bPermitFile = true;
            break;
         }
         else
         {
            $bPermitFile = false;
         }
      }
      if($bPermitFile === false)
      {
         $sMessage = $owl_lang->err_not_valid_file_type;
      }
   }   
   else
   {
      $bPermitFile = true;
   }

   if ($bPermitFile === true)
   {
      $ftmp = $_FILES['userfile']['tmp_name'];
      $fname = $default->root_folder . "/" . $_FILES['userfile']['name'];
      move_uploaded_file($ftmp, $fname);
      chmod($fname,$default->file_permission); 
   }
}   

if(isset($download))
{
   $fspath = $default->root_folder  . "/" . $download;

   if(file_exists($fspath))
   {
      $fsize = filesize($fspath); 
      header( 'Pragma: ' );
      header( 'Cache-Control: ' );
      header( 'Content-Type: application/octet-stream' );
      header( 'Content-Disposition: attachment; filename="' . $download . '"' );
      header("Content-Length: $fsize");
      header("Expires: 0");
   
      if (substr(php_uname(), 0, 7) != "Windows")
      {
         $fp = fopen("$fspath", "r");
      }
      else
      {
         $fp = fopen("$fspath", "rb");
      }
      fpassthru($fp);
   }
   else
   {
      $sMessage = $owl_lang->err_file_not_accessible;
   }

   exit();
}

include("lib/header.inc");
include("lib/userheader.inc");


if (!file_exists($default->root_folder))
{
   exit("$owl_lang->err_root_does_not_exists $default->root_folder");
}

print("<form name=\"FileList\" enctype=\"multipart/form-data\" action=\"" . $_SERVER["PHP_SELF"] ."\" method=\"post\">\n
                        <input type=\"hidden\" name=\"folder\" value=\"$folder\"></input>\n");
print("<table class=\"border1\" cellspacing=\"0\" cellpadding=\"0\" border=\"0\" width=\"90%\"><tr><td align=\"left\" valign=\"top\" width=\"100%\">\n");
print("<br />\n");
print("<table class=\"border2\" cellspacing=\"0\" cellpadding=\"0\" border=\"0\" width=\"100%\"><tr><td align=\"left\" valign=\"top\" width=\"100%\">\n");
                                                                                                                                                                                                 
print("<br />\n");

print("<table class=\"margin2\" cellspacing=\"0\" cellpadding=\"0\" border=\"0\" width=\"100%\"><tr><td align=\"left\" valign=\"top\">\n");
print("<table cellspacing=\"0\" cellpadding=\"0\" border=\"0\" width=\"100%\">");
if(!empty($sMessage))
{
   print("<tr><td class=\"admin3\" width=\"100%\" colspan=\"10\">$sMessage</td></tr>\n");
}
print("<tr><td class=\"admin0\" width=\"100%\" colspan=\"10\">$owl_lang->site_title</td></tr>\n");

// 
// Show the Directories in the
// Recycle Bin
// 

$iCountLines = 0;

if ($Dir = opendir($default->root_folder))
{
   print("<tr><td class=\"dir1\" colspan=\"10\" height=\"20\" align=\"left\">$owl_lang->current_folder ");
   $aBreadCrumb = array();
   $aBreadCrumb =  split("\/",  $folder);
   $sPath  = $sRootFolderName;

   $iFirstime = true;

   foreach(  $aBreadCrumb as $sDirectory)
   {
      if ($iFirstime === false)
      {
         $sPath .= "/" . $sDirectory;
      }
      else
      {
         $iFirstime = false;
      }
      print("/<a class=\"lfile1\" href=\"" . $_SERVER["PHP_SELF"] . "?folder=" . $sPath . "\">$sDirectory</a>");
   }
   print("</td></tr>");

   print("<tr><td class=\"title1\" align=\"left\">&nbsp;</td>");
   print("<td class=\"title1\" align=\"left\">$owl_lang->title_name</td>");
   if ($default->display_permissions)
   {
      print("<td class=\"title1\" align=\"left\">$owl_lang->title_permission</td>");
   }
   if ($default->display_size)
   {
      print("<td class=\"title1\" align=\"left\">$owl_lang->title_size</td>");
   }
   if ($default->display_last_modified)
   {
      print("<td class=\"title1\" align=\"left\">$owl_lang->title_last_modified</td></tr>");
   }


   if (!($sRecyclePath == $sRootFolderName))
   { 
      $filesearch = explode('/', $sRecyclePath);
      $extensioncounter = 0;
      while ($filesearch[$extensioncounter + 1] != null)
      { 
         // pre-append a "." separator in the name for each
         // subsequent part of the the name of the file.
         if ($extensioncounter != 0)
         {
            $firstpart = $firstpart . "/";
         } 
         $firstpart = $firstpart . $filesearch[$extensioncounter];
         $extensioncounter++;
      } 

      if ($extensioncounter == 0)
      {
         $firstpart = $filename;
         $file_extension = '';
      } 
      else
      {
         $file_extension = $filesearch[$extensioncounter];
      } 

      print("\t\t\t\t<tr>");
      print("<td class=\"title1\" width=\"1%\" align=\"left\"><img src=\"graphics/folder_closed.gif\" border=\"0\" alt=\"\"></img></td>\n");
      print("<td class=\"title1\" align=\"left\"><a class=\"lfile1\" href=\"" . $_SERVER["PHP_SELF"] . "?folder=" . $firstpart . "\">..</a></td>\n");
      if ($default->display_permissions)
      {
         print("<td class=\"title1\" align=\"left\">&nbsp;</td>\n");
      }
      if ($default->display_size)
      {
         print("<td class=\"title1\" align=\"left\">&nbsp;</td>\n");
      }
      if ($default->display_last_modified)
      {
         print("<td class=\"title1\" align=\"left\">&nbsp;</td>\n");
      }
      print("</tr>\n");
   } 

   while ($file = readdir($Dir))
   {
      if ($file[0] == '.')
      {
         continue;
      } 
      if (!is_file($default->root_folder . "/" . $file))
      {
         $iCountLines++;
         $iPrintLines = $iCountLines % 2;
         if ($iPrintLines == 0)
         {
            $sTrClass = "file1";
            $sLfList = "lfile1";
         }
         else
         {
            $sTrClass = "file2";
            $sLfList = "lfile1";
         }
         print("<tr>\n");
         print("<td class=\"$sTrClass\"><img src=\"graphics/folder_closed.gif\" border=\"0\" alt=\"\"></img></td>\n<td width=\"100%\" class=\"$sTrClass\"><a class=\"$sLfList\" href=\"" . $_SERVER["PHP_SELF"] ."?folder=" . $sRecyclePath . "/" . $file . "\">" . $file . "</a></td>\n");
         if ($default->display_permissions)
         {
            print("<td class=\"$sTrClass\" align=\"left\">&nbsp;</td>\n");
         }
         if ($default->display_size)
         {
            print("<td class=\"$sTrClass\" align=\"left\">&nbsp;</td>\n");
         }
         if ($default->display_last_modified)
         {
            print("<td class=\"$sTrClass\" align=\"left\">&nbsp;</td>\n");
         }
         print("</tr>\n");
      } 
   } 
} 
else
{
   exit($owl_lang->err_general);
} 
// 
// Show the Files in the
// Recycle Bin
// 
if ($Dir = opendir($default->root_folder))
{
   while ($file = readdir($Dir))
   {
      if ($file[0] == '.')
         continue;

      if (is_file($default->root_folder . "/" . $file))
      {
         $iCountLines++;
         $iPrintLines = $iCountLines % 2;
         if ($iPrintLines == 0)
         {
            $sTrClass = "file1";
            $sLfList = "lfile1";
         }
         else
         {
            $sTrClass = "file2";
            $sLfList = "lfile1";
         }
         print("\n<tr>\n<td  class=\"$sTrClass\" width=\"1%\">");


      $choped = split("\.", $file);
      $pos = count($choped);
      if ( $pos > 1 )
      {
         $ext = strtolower($choped[$pos-1]);
         $sDispIcon = $ext;
      }
      else
      {
         $sDispIcon = "NoExtension";
      }
                                                                                                                                                                                                  
      if (($ext == "gz") && ($pos > 2))
      {
         $exttar = strtolower($choped[$pos-2]);
         if (strtolower($choped[$pos-2]) == "tar")
            $ext = "tar.gz";
      }
                                                                                                                                                                                                  
         if (!file_exists("$default->root_fs/graphics/icon_filetype/$sDispIcon.gif"))
         {
            $sDispIcon = "file";
         }
         print("<img src=\"graphics/icon_filetype/$sDispIcon.gif\" border=\"0\" alt=\"\"></img>");
         print("</td>\n<td class=\"$sTrClass\">");
         print("<a class=\"$sLfList\" href=\"" . $_SERVER["PHP_SELF"] ."?folder=" . $sRecyclePath . htmlentities("&") . "download=$file\">" . $file . "</a>");
         print("</td>\n");
         if ($default->display_permissions)
         {
            print("<td class=\"$sTrClass\">" . fShowPerms($default->root_folder . "/" . $file) ."</td>\n");
         }
         if ($default->display_size)
         {
            print("<td class=\"$sTrClass\">" . gen_filesize(filesize($default->root_folder . "/" . $file)) ."</td>\n");
         }
         if ($default->display_last_modified)
         {
            print("<td class=\"$sTrClass\">" . date("M d, Y \a\\t h:i a", filemtime($default->root_folder . "/" . $file)) ."</td>\n");
         }
         print("</tr>\n");
      } 
   } 
} 
else
{
   exit($owl_lang->err_general);
} 

print("<tr><td  class=\"$sTrClass\" colspan=\"" . (2 + $iNumberOfOptionalColumns) . "\" height=\"40\" align=\"left\">&nbsp;</td></tr>\n");
print("<tr>\n");
print("<td colspan=\"" . (1 + $iNumberOfOptionalColumns) . "\" class=\"form1\">&nbsp;</td>\n");
print("<td class=\"form2\" width=\"100%\" nowrap=\"nowrap\">");
print("<input type=\"file\" name=\"userfile\" size=\"80\" maxlength=\"512\"></input>");
print("<input name='btn_add_file' type='submit' value='$owl_lang->btn_add_update' title='$owl_lang->alt_btn_add_update'></input>");
print("</td>");
print("</tr>");
print("</table>");
print("</td></tr></table>\n");
print("<br />\n");
print("</td></tr></table>\n");

include("lib/footer.inc");

?>
